package it.unibas.morracineseping.controllo;

import it.unibas.morracineseping.Costanti;
import it.unibas.morracineseping.modello.Partita;
import it.unibas.morracineseping.vista.presentationmodel.GiocoPM;
import it.unibas.morracineseping.vista.presentationmodel.ManoPM;
import it.unibas.morracineseping.vista.presentationmodel.PartitaPM;
import it.unibas.ping.annotazioni.Inietta;
import it.unibas.ping.azioni.AzionePingAstratta;
import it.unibas.ping.framework.Controllo;
import it.unibas.ping.framework.StatoPing;
import java.util.EventObject;

public abstract class AzioneGioca extends AzionePingAstratta {
    
    private GiocoPM gioco;
    private PartitaPM partita;
    
    public void gioca(int giocata) {
        ManoPM mano = partita.giocaMano(giocata);
        super.modello.putBean(Costanti.MANO, mano);
        if (partita.getStato() != Partita.PARTITAINCORSO) {
            gioco.gestisciPartita(partita);
            super.modello.putBean(Controllo.STATO, new StatoPing(Costanti.STATO_NO_PARTITA));
        }
    }

    public boolean abilita(Integer statusId) {
        if (statusId == Costanti.STATO_PARTITA) {
            return true;
        }
        return false;
    }
    
    public boolean disabilita(Integer statusId) {
        if (statusId == Costanti.STATO_NO_PARTITA) {
            return true;
        }
        return false;
    }
    
    public abstract void esegui(EventObject object);

    @Inietta(Costanti.PARTITA)
    public void setPartita(PartitaPM partita) {
        this.partita = partita;
    }
    
    @Inietta(Costanti.GIOCO)
    public void setGioco(GiocoPM gioco) {
        this.gioco = gioco;
    }
    
}
