package it.unibas.morracineseping.modello;

import it.unibas.morracineseping.Costanti;
import it.unibas.ping.framework.Applicazione;
import it.unibas.ping.framework.Modello;

public class Partita {
        
    public final static int LIMITEMANI = 3;
    
    public final static int PARTITAVINTADALCOMPUTER = 0;
    public final static int PARTITAVINTADALGIOCATORE = 1;
    public final static int PARTITAINCORSO = 2;
    
    private int maniVinteDalComputer;
    private int maniVinteDalGiocatore;
    private int pareggi;
    private int stato = PARTITAINCORSO;
    
    public Mano giocaMano(int giocata) {
        assert(this.getStato() == Partita.PARTITAINCORSO) : "Partita conclusa. Stato partita: " + this.getStato();
        Mano mano = new Mano();
        mano.gioca(giocata);
        int esito = mano.getEsito();
        if (esito == Mano.MANOVINTADALCOMPUTER) {
            this.setManiVinteDalComputer(this.getManiVinteDalComputer() + 1);
        } else if (esito == Mano.MANOVINTADALGIOCATORE) {
            this.setManiVinteDalGiocatore(this.getManiVinteDalGiocatore() + 1);
        } else if (esito == Mano.MANOINPAREGGIO) {
            this.setPareggi(this.getPareggi() + 1);
        }
        this.verificaStato();
        return mano;
    }
        
    public void verificaStato() {
        if (this.getManiVinteDalComputer() == Partita.LIMITEMANI) {
            stato = Partita.PARTITAVINTADALCOMPUTER;
            return;
        }
        if (this.getManiVinteDalGiocatore() == Partita.LIMITEMANI) {
            stato = Partita.PARTITAVINTADALGIOCATORE;
            return;
        }
    }
    
    public int getStato(){
        return this.stato;
    }

    public int getManiVinteDalComputer() {
        return maniVinteDalComputer;
    }
    
    public void setManiVinteDalComputer(int maniVinteDalComputer) {
        this.maniVinteDalComputer = maniVinteDalComputer;
    }
    
    public int getManiVinteDalGiocatore() {
        return maniVinteDalGiocatore;
    }
    
    public void setManiVinteDalGiocatore(int maniVinteDalGiocatore) {
        this.maniVinteDalGiocatore = maniVinteDalGiocatore;
    }
    
    public int getPareggi() {
        return pareggi;
    }
    
    public void setPareggi(int pareggi) {
        this.pareggi = pareggi;
    }
                    
}
