package it.unibas.morracineseping.vista;

import it.unibas.morracineseping.controllo.AzioneGiocaCarta;
import it.unibas.morracineseping.controllo.AzioneGiocaForbici;
import it.unibas.morracineseping.controllo.AzioneGiocaSasso;
import it.unibas.morracineseping.controllo.AzioneInterrompiPartita;
import it.unibas.morracineseping.controllo.AzioneNuovaPartita;
import it.unibas.morracineseping.modello.Gioco;
import it.unibas.ping.azioni.AzioneEsci;
import it.unibas.ping.azioni.AzioneInformazioniApplicazione;
import it.unibas.ping.azioni.AzioneInformazioniPing;
import it.unibas.ping.framework.FramePing;

public class FramePrincipale extends FramePing {
    
    /* *******************************************
     *       Frame principale 
     * ********************************************/

    public void inizializza() {
        creaMenu();
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        this.setTitle("La Morra Cinese");
        PannelloPartita pannelloPartita = 
                (PannelloPartita)vista.getSottoVista(PannelloPartita.class.getName());
        this.getContentPane().add(pannelloPartita);
        this.pack();
    }
            
    private void creaMenu() {
        javax.swing.JMenuBar barraMenu = new javax.swing.JMenuBar();
        this.setJMenuBar(barraMenu);
        creaMenuGioco(barraMenu);
        creaMenuPartita(barraMenu);
        creaMenuHelp(barraMenu);
    }
    
    private void creaMenuGioco(javax.swing.JMenuBar barraMenu) {
        javax.swing.JMenu menuGioco = new javax.swing.JMenu("Gioco");
        menuGioco.setMnemonic(java.awt.event.KeyEvent.VK_G);
        barraMenu.add(menuGioco);
        javax.swing.JMenuItem voceNuovaPartita = 
                new javax.swing.JMenuItem(controllo.getAzioneSwing(AzioneNuovaPartita.class.getName()));
        javax.swing.JMenuItem voceInterrompiPartita = 
                new javax.swing.JMenuItem(controllo.getAzioneSwing(AzioneInterrompiPartita.class.getName()));
        javax.swing.JMenuItem voceEsci = 
                new javax.swing.JMenuItem(controllo.getAzioneSwing(AzioneEsci.class.getName()));
        menuGioco.add(voceNuovaPartita);
        menuGioco.add(voceInterrompiPartita);
        menuGioco.addSeparator();
        menuGioco.add(voceEsci);
    }
    
    private void creaMenuPartita(javax.swing.JMenuBar barraMenu) {
        javax.swing.JMenu menuPartita = new javax.swing.JMenu("Partita");
        menuPartita.setMnemonic(java.awt.event.KeyEvent.VK_P);
        barraMenu.add(menuPartita);
        javax.swing.JMenuItem voceCarta = 
                new javax.swing.JMenuItem(controllo.getAzioneSwing(AzioneGiocaCarta.class.getName()));
        javax.swing.JMenuItem voceForbici = 
                new javax.swing.JMenuItem(controllo.getAzioneSwing(AzioneGiocaForbici.class.getName()));
        javax.swing.JMenuItem voceSasso = 
                new javax.swing.JMenuItem(controllo.getAzioneSwing(AzioneGiocaSasso.class.getName()));
        menuPartita.add(voceCarta);
        menuPartita.add(voceForbici);
        menuPartita.add(voceSasso);
    }

    private void creaMenuHelp(javax.swing.JMenuBar barraMenu) {
        javax.swing.JMenu menuHelp = new javax.swing.JMenu("Informazioni");
        menuHelp.setMnemonic(java.awt.event.KeyEvent.VK_H);
        barraMenu.add(menuHelp);
        javax.swing.JMenuItem voceInformazioni = 
                new javax.swing.JMenuItem(controllo.getAzioneSwing(AzioneInformazioniApplicazione.class.getName()));
        javax.swing.JMenuItem voceInformazioniPing = 
                new javax.swing.JMenuItem(controllo.getAzioneSwing(AzioneInformazioniPing.class.getName()));
        menuHelp.add(voceInformazioni);
        menuHelp.add(voceInformazioniPing);
    }

    /* *******************************************
     *              Finestre di dialogo
     * ********************************************/

    public void finestraPunteggio() {
        Gioco gioco = (Gioco)modello.getBean("gioco");
        StringBuffer messaggio = new StringBuffer();
        messaggio.append("Partite vinte dal giocatore: ");
        messaggio.append(gioco.getPartiteVinteDalGiocatore() + "\n");
        messaggio.append("\n");
        messaggio.append("Partite vinte dal computer: ");
        messaggio.append(gioco.getPartiteVinteDalComputer() + "\n");
        javax.swing.JOptionPane.showMessageDialog(this, messaggio.toString(), "Punteggi", javax.swing.JOptionPane.INFORMATION_MESSAGE);
    }
           
}


