package it.unibas.morracineseping.vista;

import com.jeta.forms.components.panel.FormPanel;
import it.unibas.morracineseping.Costanti;
import it.unibas.morracineseping.controllo.AzioneGiocaCarta;
import it.unibas.morracineseping.controllo.AzioneGiocaForbici;
import it.unibas.morracineseping.controllo.AzioneGiocaSasso;
import it.unibas.morracineseping.controllo.AzioneInterrompiPartita;
import it.unibas.morracineseping.controllo.AzioneNuovaPartita;
import it.unibas.ping.binding.osservatori.IOsservatore;
import it.unibas.ping.binding.osservatori.OsservatoreIcona;
import it.unibas.ping.binding.osservatori.OsservatoreLabel;
import it.unibas.ping.framework.PannelloPing;

public class PannelloPartita extends PannelloPing {
        
    private FormPanel pannello;
    
    public void inizializza() {
        this.pannello = new FormPanel("it/unibas/morracineseping/vista/PannelloPartita.jfrm");
        this.add(pannello);
        assegnaAzioni();
        creaOsservatoriGioco();
        creaOsservatoriPartita();
    }
    
    private void assegnaAzioni() {
        super.vista.assegnaAzione("bottoneNuovaPartita", AzioneNuovaPartita.class.getName());
        super.vista.assegnaAzione("bottoneInterrompiPartita", AzioneInterrompiPartita.class.getName());
        super.vista.assegnaAzione("bottoneCarta", AzioneGiocaCarta.class.getName());
        super.vista.assegnaAzione("bottoneForbici", AzioneGiocaForbici.class.getName());
        super.vista.assegnaAzione("bottoneSasso", AzioneGiocaSasso.class.getName());
    }
    
    private void creaOsservatoriGioco() {
        IOsservatore ossPC = new OsservatoreLabel("labelPartiteComputer", Costanti.GIOCO, Costanti.PARTITE_COMPUTER);
        IOsservatore ossPG = new OsservatoreLabel("labelPartiteGiocatore", Costanti.GIOCO, Costanti.PARTITE_GIOCATORE);        
    }
    
    private void creaOsservatoriPartita() {
        IOsservatore ossMG = new OsservatoreLabel("labelManiGiocatore", Costanti.PARTITA, Costanti.MANI_GIOCATORE);
        IOsservatore ossMC = new OsservatoreLabel("labelManiComputer", Costanti.PARTITA, Costanti.MANI_COMPUTER);
        IOsservatore ossP = new OsservatoreLabel("labelPareggi", Costanti.PARTITA, Costanti.PAREGGI);
        IOsservatore oIG = new OsservatoreIcona("labelGiocataGiocatore", Costanti.MANO, Costanti.ICONA_GIOCATORE);
        IOsservatore oIC = new OsservatoreIcona("labelGiocataComputer", Costanti.MANO, Costanti.ICONA_COMPUTER);
        IOsservatore ossM1 = new OsservatoreLabel("labelMessaggioMano", Costanti.MANO, Costanti.ESITO_MANO);
        IOsservatore ossM2 = new OsservatoreLabel("labelMessaggioPartita", Costanti.PARTITA, Costanti.MESSAGGIO_PARTITA);
    }
            
}
