package it.unibas.morracineseping.vista.presentationmodel;

import it.unibas.morracineseping.modello.Mano;
  
public class ManoPM {

    private Mano mano;
    private String stringaEsitoMano;
    public final static String prefissoRisorse = "/risorse/";
    public final static String ICONA_CARTA_GIOCATORE = prefissoRisorse + "carta1.gif";
    public final static String ICONA_FORBICI_GIOCATORE = prefissoRisorse + "forbici1.gif";
    public final static String ICONA_SASSO_GIOCATORE = prefissoRisorse + "sasso1.gif";
    
    public final static String ICONA_CARTA_COMPUTER = prefissoRisorse + "carta2.gif";
    public final static String ICONA_FORBICI_COMPUTER = prefissoRisorse + "forbici2.gif";
    public final static String ICONA_SASSO_COMPUTER = prefissoRisorse + "sasso2.gif";
            
    public ManoPM(Mano mano) {
        this.mano = mano;
    }
    
    public void gioca(int giocataGiocatore) {
        this.mano.gioca(giocataGiocatore);
    }
    
    public String getIconaGiocatore() {
        return stringaIconaGiocatore(this.mano.getGiocataGiocatore());
    }

    public String getIconaComputer() {
        return stringaIconaComputer(this.mano.getGiocataComputer());
    }

    public String getEsitoMano() {
        if (this.mano.getEsito() == Mano.MANOVINTADALCOMPUTER) {
            return "Il computer ha vinto la mano";
        }
        if (this.mano.getEsito() == Mano.MANOVINTADALGIOCATORE) {
            return "Bravo, hai vinto la mano";
        }
        return "Si e' verificato un pareggio";
    }
    
    public static String stringaIconaGiocatore(int mossa) {
        if (mossa == Mano.CARTA) {
            return ICONA_CARTA_GIOCATORE;
        } else if (mossa == Mano.FORBICI) {
            return ICONA_FORBICI_GIOCATORE;
        }
        return ICONA_SASSO_GIOCATORE;
    }
    
    public static String stringaIconaComputer(int mossa) {
        if (mossa == Mano.CARTA) {
            return ICONA_CARTA_COMPUTER;
        } else if (mossa == Mano.FORBICI) {
            return ICONA_FORBICI_COMPUTER;
        }
        return ICONA_SASSO_COMPUTER;
    }
        
    public static java.net.URL urlIcona(String nomeIcona) {
        java.net.URL url = ManoPM.class.getResource(nomeIcona);
        return url;
    }

}

