package it.unibas.morracineseping.vista.presentationmodel;

import it.unibas.morracineseping.Costanti;
import it.unibas.morracineseping.modello.Mano;
import it.unibas.morracineseping.modello.Partita;
import it.unibas.ping.framework.Applicazione;
import it.unibas.ping.framework.Modello;

public class PartitaPM {
    
    private Modello modello = Applicazione.getInstance().getModello();
    private Partita partita = new Partita();

    private String messaggioPartita = "Utilizza i pulsanti o il menu per giocare";
            
    public ManoPM giocaMano(int giocata) {
        Mano mano = this.partita.giocaMano(giocata);
        modello.notificaModificaProprieta(this, Costanti.MANI_COMPUTER);
        modello.notificaModificaProprieta(this, Costanti.MANI_GIOCATORE);
        modello.notificaModificaProprieta(this, Costanti.PAREGGI);
        this.aggiornaMessaggio();
        return new ManoPM(mano);
    }

    public void aggiornaMessaggio() {
        if (this.partita.getStato() == Partita.PARTITAVINTADALCOMPUTER) {
            this.messaggioPartita = "Peccato, il computer ha vinto la partita";    
        } else if (this.partita.getStato() == Partita.PARTITAVINTADALGIOCATORE) {
            this.messaggioPartita = "Bravo ! Hai vinto la partita";
        } else {
            this.messaggioPartita = "";
        }
        modello.notificaModificaProprieta(this, Costanti.MESSAGGIO_PARTITA);
    }
    
    public int getManiVinteDalComputer() {
        return this.partita.getManiVinteDalComputer();
    }
        
    public int getManiVinteDalGiocatore() {
        return this.partita.getManiVinteDalGiocatore();
    }
        
    public int getPareggi() {
        return this.partita.getPareggi();
    }
                
    public String getMessaggioPartita() {
        return messaggioPartita;
    }
         
    public int getStato() {
        return this.partita.getStato();
    }
    
    public Partita getPartita() {
        return this.partita;
    }
}
